<?php

namespace App\Http\Controllers;

use App\Models\Testimonials;
use App\Models\About;
use Illuminate\Http\Request;
use File;

class AboutUsController extends Controller
{
    public function getContactUs(Request $request)
    {
        $about = About::first();
        if (isset($about['about_id'])) {
            $testimonials = Testimonials::where('about_id', $about['about_id'])->get();
            $about['testimonials'] = $testimonials;
        }

        return view('about-us.index', compact('about'));
    }

    public function AboutUsUpload(Request $request)
    {
        $data = $request->all();

        $detail = [
            'header' =>  $data['header'],
            'header_short_desc' =>  $data['header_short_desc'],
            'header_long_desc' =>  $data['header_long_desc'],
        ];

        $resourceImage = $data['image_name'];
        if ($resource = $request->file('image')) {

            $imageExists = public_path('aboutus/' .  $resourceImage);
            if (File::exists($imageExists)) {
                unlink($imageExists);
            }

            $destinationPath = 'aboutus/';
            $resourceImage = date('YmdHis') . "." . $resource->getClientOriginalExtension();
            $resource->move($destinationPath, $resourceImage);
            $detail['image'] = "$resourceImage";
        }

        if ($data['about_id'] == null) {

            $aboutUs =  About::create($detail);

            if (isset($data['testimonials']) && !empty($data['testimonials'])) {

                $testimonials = [];
                foreach ($data['testimonials'] as $val) {
                    $val['about_id'] = $aboutUs['id'];
                    $testimonials[] =  $val;
                }
                Testimonials::insert($testimonials);
            }

            return back()->with('success', __('messages.add', ['name' => 'About Us']));
        } else {
            About::where('about_id', $data['about_id'])->update($detail);

            Testimonials::where('about_id', $data['about_id'])->delete();
            if (isset($data['testimonials']) && !empty($data['testimonials'])) {

                $testimonials = [];
                foreach ($data['testimonials'] as $val) {
                    $val['about_id'] = $data['about_id'];
                    $testimonials[] =  $val;
                }
                Testimonials::insert($testimonials);
            }

            return back()->with('success', __('messages.edit', ['name' => 'About Us']));
        }
    }
}
