<?php

namespace App\Http\Controllers\Auth;

use App\Models\User;
use App\Models\AppUser;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use App\Providers\RouteServiceProvider;
use Illuminate\Support\Facades\Session;
use Illuminate\Foundation\Auth\AuthenticatesUsers;

class LoginController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $redirectTo = RouteServiceProvider::HOME;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest')->except('logout');
    }


    public function loginSubmit(Request $request){

        

        if (Auth::guard('web')->attempt(['email' => $request->email, 'password' => 
            $request->password])) {
                $adminInfo = User::where('email','=', $request->email)->first();
                Auth::login($adminInfo);
            return redirect(route('articles.list'));
        }

        if (Auth::guard('app_user')->attempt(['email' => $request->email, 'password' => 
            $request->password])) {
                $adminInfo = AppUser::where('email','=', $request->email)->first();
                Auth::login($adminInfo);
                Session::put('app_user_id', $adminInfo->app_user_id);
            return redirect(route('transaction.user.list'));
        }
    }
}
