<?php

namespace App\Http\Controllers;

use DB;
use Hash;
use Mail;
use Carbon\Carbon;
use App\Models\User;
use App\Models\AppUser;
use Illuminate\Support\Str;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Session;


class ForgotPasswordController extends Controller
{
    /**
     * Write code on Method
     *
     * @return response()
     */
    public function showForgetPasswordForm()
    {
        return view('admin.forgetPassword');
    }

    /**
     * Write code on Method
     *
     * @return response()
     */
    public function submitForgetPasswordForm(Request $request)
    {
        // |exists:users
        $request->validate([
            'email' => 'required|email',
        ]);
        $admin = User::where('email', $request->email)->count();
        $user_data = AppUser::where('email', 'dipak.imphatic@gmail.com')->get();
       
        if ($admin || $user_data) {
            if ($admin) {
                $token = Str::random(64);
    
                DB::table('password_resets')->insert([
                    'email' => $request->email,
                    'token' => $token,
                    'created_at' => Carbon::now()
                ]);
    
                $link = route('reset.password.get', [$token, 'email' => $request->email]);
    
                Mail::send('mails.forgetPassword', ['link' => $link], function ($message) use ($request) {
                    $message->to($request->email);
                    $message->subject('Luxury Council - Reset Password');
                });
    
                return back()->with('message', 'We have e-mailed your password reset link!');
            }
            if($user_data){
                $token = Str::random(64);
    
                DB::table('app_user_password_resets')->insert([
                    'email' => $request->email,
                    'token' => $token,
                    'created_at' => Carbon::now()
                ]);
    
                $link = route('app.reset.password.get', [$token, 'email' => $request->email]);
    
                Mail::send('mails.forgetPassword', ['link' => $link], function ($message) use ($request) {
                    $message->to('dipak.imphatic@gmail.com');
                    $message->subject('Luxury Council - Reset Password');
                });
    
                return back()->with('message', 'We have e-mailed your password reset link!');
            }
            
        }else{
            return back()->with('message', 'Incorrect Email');
        }
       
        
    }

    /**
     * Write code on Method
     *
     * @return response()
     */
    public function showResetPasswordForm($token, Request $request)
    {
        $email = $request->get('email');
        return view('admin.forgetPasswordLink', ['token' => $token, 'email' => $email]);
    }

    /**
     * Write code on Method
     *
     * @return response()
     */
    public function submitResetPasswordForm(Request $request)
    {
        // exists:users
       
            $request->validate([
                'email' => 'required|email|exists:users',
                'password' => 'required|string|min:6|confirmed',
                'password_confirmation' => 'required'
            ]);
    
            $updatePassword = DB::table('password_resets')
                ->where([
                    'email' => $request->email,
                    'token' => $request->token
                ])
                ->first();
    
            if (!$updatePassword) {
                return back()->withInput()->with('error', 'Invalid token!');
            }
    
            $user = User::where('email', $request->email)
                ->update(['password' => Hash::make($request->password)]);
    
            DB::table('password_resets')->where(['email' => $request->email])->delete();
    
            return redirect('/login')->with('message', 'Your password has been changed!');
        
        
    }

    /**
     * Write code on Method
     *
     * @return response()
     */
    public function showAppResetPasswordForm($token, Request $request)
    {
        $email = $request->get('email');
        return view('admin.appForgetPasswordLink', ['token' => $token, 'email' => $email]);
    }

     /**
     * Write code on Method
     *
     * @return response()
     */
    public function submitAppResetPasswordForm(Request $request)
    {
        $request->validate([
            'email' => 'required|email|exists:app_users',
            'password' => 'required|string|min:6|confirmed',
            'password_confirmation' => 'required'
        ]);

        $updatePassword = DB::table('app_user_password_resets')
            ->where([
                'email' => $request->email,
                'token' => $request->token
            ])
            ->first();

        if (!$updatePassword) {
            return back()->withInput()->with('error', 'Invalid token!');
        }

        $user = \App\Models\AppUser::where('email', $request->email)
            ->update(['password' => Hash::make($request->password)]);

        DB::table('app_user_password_resets')->where(['email' => $request->email])->delete();

        return redirect('/login')->with('message', 'Your password has been changed!');
    }
}
