<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DataTables;
use Illuminate\Support\Facades\DB;
use App\Models\GroupSubscriptionTransactionHistory;
use DateTime;
class GroupSubscriptionTransactionController extends Controller
{
    public function __construct()
    {
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $subscripation = \App\Models\Subscription::pluck('subscription_name', 'subscription_id');
        $group_subscription_id = $request->query('group_subscription_id') ? $request->query('group_subscription_id') : '';
        return view('group-transaction.index', ['group_subscription_id' => $group_subscription_id, 'subscripation' => $subscripation]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
       //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
         }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        }

    public function ajaxList(Request $request)
    {
        if ($request->ajax()) {
            $columns = ['group_subscriptions.title', 'subscription.subscription_name', 'subscription_type', 'subscription_start_date', 'subscription_end_date', 'amount'];
            $transaction  = GroupSubscriptionTransactionHistory::select(DB::raw('group_subscriptions.title AS group_subscription_title'), DB::raw('subscription.subscription_name AS subscription_name'), 'group_subscription_transaction_histories.subscription_type', 'group_subscription_transaction_histories.subscription_start_date', 'group_subscription_transaction_histories.subscription_end_date', 'group_subscription_transaction_histories.amount');
            $transaction->leftJoin('group_subscriptions', 'group_subscriptions.group_subscription_id', '=', 'group_subscription_transaction_histories.group_subscription_id');
            $transaction->leftJoin('subscription', 'subscription.subscription_id', '=', 'group_subscription_transaction_histories.subscription_id');

            $columnIndex = $request->input('order.0.column');
            $columnName = $columns[$columnIndex];
            $columnSortOrder = $request->input('order.0.dir');

            if($request->group_subscription_id != 0){
                $transaction->where('group_subscriptions.group_subscription_id', $request->group_subscription_id);
            }

            $transaction->orderBy($columnName, $columnSortOrder);

            $data = $transaction->get();
            return DataTables::of($transaction)
                ->addColumn('subscription_type', function ($row) {
                    return $row->subscription_type == 1 ? 'Monthly' : 'Yearly';
                })
                ->addColumn('created_at', function ($row) {
                    return date('Y-m-d H:i:s', strtotime($row->created_at));
                })
                ->addColumn('subscription_start_date', function ($row) {
                    return !is_null($row->subscription_start_date) ?  date('Y-m-d H:i:s', strtotime($row->subscription_start_date)) : '-';
                })
                ->addColumn('subscription_end_date', function ($row) {
                    return !is_null($row->subscription_end_date) ?  date('Y-m-d H:i:s', strtotime($row->subscription_end_date)) : '-';
                })
                ->addColumn('amount', function ($row) {
                    return '$'.number_format($row->amount, 2);
                })
                ->addColumn('subscription_status', function ($row) {
                    $date1 = date_create(now());
                    $date2 = date_create($row->subscription_end_date);
                    $diff = date_diff($date1,$date2);
                    $daysDifference = (int) $diff->format("%R%a");

                    return ($daysDifference > 7 ? '<div style="color:green;">' . $daysDifference . ' Remaning Days </div>' :
                        ($daysDifference <= 7  && $daysDifference > 0 ? '<div style="color:orange;">' . $daysDifference . ' Remaning Days </div>' : '<div style="color:red;"> Expired </div>'));
                })
                ->filter(function ($query) use ($request) {

                    if (isset($request->group_subscription_title)) {
                        $search = '%' . $request->group_subscription_title . '%';
                        $query->where("group_subscriptions.title", "LIKE", $search);
                    }
                    if (isset($request->subscription_name)) {
                        $search = '%' . $request->subscription_name . '%';
                        $query->where("subscription.subscription_name", "LIKE", $search);
                    }
                    if (isset($request->subscription_id)) {
                        $search = '%' . $request->subscription_id . '%';
                        $query->where("group_subscription_transaction_histories.subscription_id", "LIKE", $search);
                    }
                    if (isset($request->subscription_type)) {
                        $query->where("group_subscription_transaction_histories.subscription_type", $request->subscription_type);
                    }
                    if (isset($request->subscription_start_date)) {
                        $query->whereRaw("DATE(group_subscription_transaction_histories.subscription_start_date) = ?", [$request->subscription_start_date]);
                    }
                    if (isset($request->subscription_end_date)) {
                        $query->whereRaw("DATE(group_subscription_transaction_histories.subscription_end_date) = ?", [$request->subscription_end_date]);
                    }
                })
                ->rawColumns(['subscription_type', 'subscription_status', 'amount'])
                ->make(true);
        }
    }

}
