<?php

namespace App\Http\Controllers;

use DataTables;
use Carbon\Carbon;
use App\Models\Interest;

use App\Models\Publisher;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\DB;
use App\Rules\UniquePublisherName;
use App\Rules\PublisherStatusChange;

class PublishController extends Controller
{
    // public function index()
    // {
    //     return view('publish.createPublish');
    // }
    
    // public function list()
    // {
    //     return view('publish.indexPublish');
    // }
    public function list(Request $request)
    {
        return view('publish.indexPublish');
    }
    public function index(Request $request,$id=0)
    {
       if(!empty($id)){
            $publisher=Publisher::where('publisher_id',$id)->first();
        }else{
            $publisher='';
        }
       
        //return view('interest.createInterest');
        return view('publish.createPublish', compact('publisher'));
    }
    public function addPublish(Request $request,$id=0)
    {
       
        $data=$request->all();
       
        if($data['publisher_id']!=null)
            {
                $this->validate($request, [
                'publisher_name'=> ['required', new UniquePublisherName($data['publisher_id'])],
                // 'publisher_status'=> new PublisherStatusChange($data['publisher_name']),
                ]);

            unset($data['_token']);
            Publisher::where('publisher_id', $data['publisher_id'])->update($data);
            return redirect()->route('publish.list')->with('message', __('messages.edit', ['name' => 'Publisher']));
        }else{
            $this->validate($request, [
                'publisher_name'=> ['required', new UniquePublisherName(0)],
            ]);
            unset($data['publisher_id']);
            Publisher::create($data);
            return redirect()->route('publish.list')->with('message', __('messages.add', ['name' => 'Publisher']));
        }
        
    }
    public function deletePublisher($id)
    {
        $p=Publisher::where('publisher_id', $id)->pluck('publisher_name')->first();

        $artical = \App\Models\Article::where('publisher',$p)->count();
        if($artical > 0 )
        {
            return redirect()->route('publish.list')->with('message_wr', __('messages.already_use', ['name' => 'Publisher']));
        }else{
            Publisher::where('publisher_id', $id)->update(['deleted_at' => Carbon::now()]);
            return redirect()->route('publish.list')->with('message', __('messages.delete', ['name' => 'Publisher']));
        }
        
    }


    public function ajaxList(Request $request)
    {

        if($request->ajax()){
            $columns = ['action','publisher_name', 'publisher_status'];
            $columnIndex = $request->input('order.0.column');
            $columnName = $columns[$columnIndex];
            $columnSortOrder = $request->input('order.0.dir');

            $data_publisher = Publisher::orderBy($columnName, $columnSortOrder);
            $data_publisher->get();

            return DataTables::of($data_publisher)
            ->addColumn('publisher_status', function ($row) {
                if($row->publisher_status==1)
                {
                    $publisher_status="Active";
                }else{
                    $publisher_status="Inactive";
                }
                return $publisher_status;
            })
            ->addColumn('action', function ($row) {
                $editUrl = route('publish.form', $row->publisher_id);
                $deleteUrl = route('publisher.delete', $row->publisher_id);
                return '<a href="'.$editUrl.'" class="btn" style="background: #000000;color: #f0ac63 !important;" title="Edit"><i class="fa fa-pencil" aria-hidden="true"></i></a>
                        <a href="'.$deleteUrl.'" class="btn" onclick="return confirm(\'Are you sure you want to delete this Publisher?\')" style="background: #f0ac63;color: #000000 !important;" title="Delete"><i class="fa fa-trash" aria-hidden="true"></i></a>';
            })
            ->rawColumns(['publisher_status','action'])
            ->addIndexColumn()
            ->make(true);
        }
    }
}
