<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Article extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table="articles";

    protected $appends  = ['is_favorite'];

    protected $fillable = [
        'subscription_level',
        'company_id',
        'category_id',
        'industry_id',
        'article_name',
        'artical_short_desc',
        'artical_long_desc',
        'visiable_after_days',
        'media_selection',
        'image',
        'youtube_url',
        'audio',
        'interest_id',
        'publisher',
        'publish_date',
        'resource',
        'search_text',
        'thumbnail_image'
    ];

    protected $hidden = [
        'created_at',
        'updated_at',
    ];

    public function getIsFavoriteAttribute($value)
    {
        return (\Auth::guard('api')->user()) ? ((\App\Models\FavoriteArticle::where([
            'article_id' => $this->attributes['article_id'],
            'app_user_id' => \Auth::guard('api')->user()->app_user_id
        ])->exists() == true) ? 1 : 0) : 0;
    }
}
