<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Category extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table = 'category';
    protected $fillable = [
        'category_name',
        'category_status'
    ];
    protected $hidden = [
        'created_at',
        'updated_at',
    ];

    public function scopeStatus($query, $value)
    {
        return $query->where('category_status', $value);
    }
}
