<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Company extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table="company";

    protected $primaryKey = 'company_id';

    protected $fillable = [
        'company_id',
        'company_name',
        'company_status'
    ];
    protected $hidden = [
        'created_at',
        'updated_at',
    ];

    public function scopeStatus($query, $value)
    {
        return $query->where('company_status', $value);
    }

}