<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Event extends Model
{
    use HasFactory, SoftDeletes;
    protected $table = 'events';

    protected $fillable = [
        'event_name',
        'event_date',
        'event_detail',
        'hash_tags',
        'event_email_subject',
        'event_email_body',
        'event_status'
    ];

    public function scopeStatus($query, $value)
    {
        return $query->where('event_status', $value);
    }
}
