<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Industry extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table="industry";

    protected $fillable = [
        'industry_name',
        'industry_status'
    ];
    protected $hidden = [
        'created_at',
        'updated_at',
    ];

    public function scopeStatus($query, $value)
    {
        return $query->where('industry_status', $value);
    }
}