<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Publisher extends Model
{
    use HasFactory, SoftDeletes;
    
    protected $table="publisher";

    protected $fillable = [
        'publisher_name',
        'publisher_status'
    ];
    protected $hidden = [
        'created_at',
        'updated_at',
    ];

    public function scopeStatus($query, $value)
    {
        return $query->where('publisher_status', $value);
    }
}