<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class SpotlightMember extends Model
{
    use HasFactory, SoftDeletes;
    protected $table = 'spotlight_members';

    protected $appends = ['spotlight_member_company_logo_link'];

    protected $fillable = [
        'spotlight_member_company_logo',
        'spotlight_member_company_short_description',
        'spotlight_member_company_long_description',
        'spotlight_member_contact_email',
        'spotlight_member_contact_name',
        'spotlight_member_status'
    ];

    function getSpotlightMemberCompanyLogoLinkAttribute(){
        return isset($this->attributes['spotlight_member_company_logo']) ? asset('spotlight-member/'.$this->attributes['spotlight_member_company_logo']) : '';
    }

    public function scopeStatus($query, $value)
    {
        return $query->where('spotlight_member_status', $value);
    }
}
