<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Article;

class CategoryStatusChange  implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $category_id;
    public function __construct($category_id)
    {
        $this->category_id = $category_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        $artical = Article::whereRaw("JSON_CONTAINS(category_id, '\"$this->category_id\"')")->count();
        return !($value == 0 && ($artical > 0 ));
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.already_use', ['name' => 'Category']);
    }
}
