<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\GroupSubscription;
use App\Models\AppUser;

class CompanyStatusChange  implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $company_id;
    public function __construct($company_id)
    {
        $this->company_id = $company_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {

       $appUser  = AppUser::where('company', $this->company_id)->count();
       $groupSubscription  = GroupSubscription::where('company_name', $this->company_id)->count();
       return !($value == 0 && ($appUser > 0 || $groupSubscription > 0));
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.already_use', ['name' => 'Company']);
    }
}
