<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Article;

class PublisherStatusChange implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $publisher_name;
    public function __construct($publisher_name)
    {
        $this->publisher_name = $publisher_name;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        $artical = Article::whereRaw('LOWER(publisher) = ?', \Str::lower($this->publisher_name))->count();
        return !($value == 0 && ($artical > 0 ));
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.already_use', ['name' => 'Publisher']);
    }
}
