<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Article;
use App\Models\AppUser;

class SubscriptionStatusChange  implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $subscription_id;
    public function __construct($subscription_id)
    {
        $this->subscription_id = $subscription_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {

       $subscriptionCount = Article::whereRaw("JSON_CONTAINS(subscription_level, '\"$this->subscription_id\"')")->count();
       $appUser  = AppUser::where('subscription_id', $this->subscription_id)->count();
       return !($value == 0 && ($subscriptionCount > 0 || $appUser > 0));
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.already_use', ['name' => 'Subscription']);
    }
}
