<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Article;

class UniqueArticalName implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $article_id;
    public function __construct($article_id)
    {
        $this->article_id = $article_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return !Article::where('article_id', '!=', $this->article_id)->whereRaw('LOWER(article_name) = ?', \Str::lower($value))->exists();
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.unique_name', ['name' => 'Article']);
    }
}
