<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Category;

class UniqueCategoryName implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $category_id;
    public function __construct($category_id)
    {
        $this->category_id = $category_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return !Category::where('category_id', '!=', $this->category_id)->whereRaw('LOWER(category_name) = ?', \Str::lower($value))->exists();
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.unique_name', ['name' => 'Category']);
    }
}
