<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Company;

class UniqueCompanyName implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $company_id;
    public function __construct($company_id)
    {
        $this->company_id = $company_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return !Company::where('company_id', '!=', $this->company_id)->whereRaw('LOWER(company_name) = ?', \Str::lower($value))->exists();
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.unique_name', ['name' => 'Company']);
    }
}
