<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Industry;

class UniqueIndustryName implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $industry_id;
    public function __construct($industry_id)
    {
        $this->industry_id = $industry_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return !Industry::where('industry_id', '!=', $this->industry_id)->whereRaw('LOWER(industry_name) = ?', \Str::lower($value))->exists();
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.unique_name', ['name' => 'Industry']);
    }
}
