<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Interest;

class UniqueInterestName implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $interest_id;
    public function __construct($interest_id)
    {
        $this->interest_id = $interest_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return !Interest::where('interest_id', '!=', $this->interest_id)->whereRaw('LOWER(interest_name) = ?', \Str::lower($value))->exists();
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.unique_name', ['name' => 'Interest']);
    }
}
