<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Publisher;

class UniquePublisherName implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $publisher_id;
    public function __construct($publisher_id)
    {
        $this->publisher_id = $publisher_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return !Publisher::where('publisher_id', '!=', $this->publisher_id)->whereRaw('LOWER(publisher_name   ) = ?', \Str::lower($value))->exists();
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.unique_name', ['name' => 'Publisher']);
    }
}
