<?php

namespace App\Rules;

use Illuminate\Contracts\Validation\Rule;
use App\Models\Subscription;

class UniqueSubscriotionName implements Rule
{
    /**
     * Create a new rule instance.
     *
     * @return void
     */
    public $subscription_id;
    public function __construct($subscription_id)
    {
        $this->subscription_id = $subscription_id;
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param  string  $attribute
     * @param  mixed  $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return !Subscription::where('subscription_id', '!=', $this->subscription_id)->whereRaw('LOWER(subscription_name) = ?', \Str::lower($value))->exists();
    }

    /**
     * Get the validation error message.
     *
     * @return string
     */
    public function message()
    {
        return  __('messages.unique_name', ['name' => 'Subscription']);
    }
}
